﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Collections;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  public class HiveExperimentDtoList : ObservableList<HiveExperimentDto>, IDeepCloneable {
    public HiveExperimentDtoList() { }
    public HiveExperimentDtoList(IEnumerable<HiveExperimentDto> collection) {
      this.list = new List<HiveExperimentDto>(collection);
    }

    [StorableConstructor]
    protected HiveExperimentDtoList(bool deserializing) : base(deserializing) { }

    public object Clone() {
      return Clone(new Cloner());
    }

    public virtual IDeepCloneable Clone(Cloner cloner) {
      HiveExperimentDtoList clone = (HiveExperimentDtoList)Activator.CreateInstance(this.GetType());
      cloner.RegisterClonedObject(this, clone);
      clone.list = (this.Select(x => (HiveExperimentDto)cloner.Clone(x))).ToList();
      return clone;
    }
  }
}
